Option Strict Off
Imports System.Collections
Imports Microsoft.Win32
Imports System.Text.RegularExpressions
Imports System.IO
Imports System.IO.MemoryMappedFiles
Imports System.Runtime.InteropServices
Imports System.Threading
Imports System.Security
Imports System.ComponentModel
Imports Microsoft.Win32.SafeHandles
Imports System.Runtime.ConstrainedExecution
Imports System.Security.Permissions

Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Xml


Public Class Class1
    Implements GOverlayPlugin.Interfaces.IPlugin
    Public testvar As Integer = 1

    Private objHost As GOverlayPlugin.Interfaces.IHost
    Public PluginName As String = "AyteeDE.AquasuiteConnector"

    Public Cache As String

    Public LastCache As New System.Collections.Hashtable


    Private IL2CoDFile As MemoryMappedFile
    Private FileMapView As MemoryMappedViewAccessor


    Public td As New System.Collections.Hashtable



    Public Sub Initialize(ByVal Host As GOverlayPlugin.Interfaces.IHost) Implements GOverlayPlugin.Interfaces.IPlugin.Initialize
        objHost = Host
    End Sub

    Public ReadOnly Property Description() As String Implements GOverlayPlugin.Interfaces.IPlugin.Description
        'Return your plugin name
        Get
            Return "This plugin allows to read the Aquiasuite sensors with comma-separated decimal values." & vbNewLine & vbNewLine &
                "Developed by AyteeDE"
        End Get
    End Property

    Public ReadOnly Property Name() As String Implements GOverlayPlugin.Interfaces.IPlugin.Name
        'Return your plugin name
        Get
            Return PluginName
        End Get
    End Property

    Public ReadOnly Property Display() As String Implements GOverlayPlugin.Interfaces.IPlugin.Display
        'Return the display this plugin belongs to
        Get
            Return "lcdsys"
        End Get
    End Property

    Function CallBack(method As String) As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.CallBacks
        'Send the request to upload all the files
        'objHost.DebugMessage("AS - Callback Requested: " & method)
        'objHost.DebugMessage("IL2 Plugin - " & method)

        Try
            Dim returnHT As Hashtable = New Hashtable

            Dim value = 0

            If method = "willrequestvalues" Then
                'Comes here once per run (only if sensors are used thru here)
                GrabData()
            ElseIf method = "willrequestdisplay" Then
                'objHost.DebugMessage("wrd")
                GrabData()
            ElseIf method = "reqimagesbutton" Then
                'objHost.AccessHost("plugin_upload_files", PluginName, "reqimages", "")
            Else
                'Dim name = method.Replace("AS.", "")
                Dim name = method
                'objHost.DebugMessage(name & " >> " & td(name))
                value = td(name)
            End If

            returnHT("value") = value

            Return returnHT
        Catch ex As Exception
            objHost.DebugMessage("Error grabbing action : " & method)
        End Try

    End Function

    Function AvailableSensors(pluginOptions As Hashtable) As System.Collections.Generic.Dictionary(Of String, String) Implements GOverlayPlugin.Interfaces.IPlugin.AvailableSensors
        'Create the list of the sensors/elements this plugin has
        'You can access your pluginOptions here as pluginOptions(your_option)        
        Try

            Dim sensors As New System.Collections.Generic.Dictionary(Of String, String)


            Dim xmldoc As New XmlDataDocument()
            Dim xmlnode As XmlNodeList
            Dim i As Integer
            Dim str As String
            Dim xmlfile = objHost.AccessHost("plugin_options", "AyteeDE.AquasuiteConnector", "xmlfile", False)
            Dim fs As New FileStream(xmlfile, FileMode.Open, FileAccess.Read)
            xmldoc.Load(fs)
            fs.Close()
            xmlnode = xmldoc.GetElementsByTagName("LogDataSet")
            For i = 0 To xmlnode.Count - 1
                Dim sensorName As String = xmlnode(i).ChildNodes.Item(2).InnerText.Trim()
                Dim sensorType As String = xmlnode(i).ChildNodes.Item(4).InnerText.Trim()

                sensors.Add("AyteeDE." & sensorType & "." & sensorName, sensorType & ": " & sensorName)
            Next

            Return sensors
        Catch ex As Exception
            objHost.DebugMessage("Error loading sensors:" & ex.Message & ": " & ex.StackTrace)
            'MsgBox(ex.Message & ":: " & ex.StackTrace)
        End Try
    End Function


    Function LCDSys2_AvailableSensors(pluginOptions As Hashtable) As System.Collections.Generic.Dictionary(Of String, String) Implements GOverlayPlugin.Interfaces.IPlugin.LCDSys2_AvailableSensors
        'Same sensors as lcd1
        Return AvailableSensors(pluginOptions)        
    End Function

    Function ComboBoxes() As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.ComboBoxes
        'Create custom ComboBox for your configuration to use
        Dim boxes As New Hashtable
        Dim myboxOptions As New Hashtable
        'Set each one of the Combobox options as value, Display Name
        'myboxOptions.Add("DiskSize", "Disk Size")
        'myboxOptions.Add("DriveLetter", "Drive Letter")
        'myboxOptions.Add("Model", "Model")
        'myboxOptions.Add("Temperature", "Temperature")
        'myboxOptions.Add("TemperatureClass", "Temperature Class")

        'Add the combobox options as the combobox "PLUG.optioncustom1"
        'boxes.Add("CM.DiskData", myboxOptions)
        Return boxes
    End Function

    Public Function SetDefaultOptions(sensorId As String, elementData As Hashtable) As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.SetDefaultOptions
        'Set the default values you want to have on your sensor when its created, if the user doesnt change any option, he will have this settings

        elementData("width") = 100
        elementData("height") = 20
            elementData("font_style") = 0
            elementData("basic_color") = 0
            elementData("font_size") = 1
            elementData("font_color") = 0
            elementData("font_transform") = 0

        'elementData("CM.DiskData") = "DiskSize"

        'elementData("font_style") = 0
        'elementData("font_size") = 10
        'elementData("max_digits") = 2

        Return elementData
    End Function

    Public Function CreateOptions(sensorId As String, elementData As Hashtable) As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.CreateOptions
        'Set the options the user will have when clicking on the element
        'The available option_types are:
        'Text: Input text
        'Combo3: Combo with options (Enabled=0, Disabled=1)
        'Sensors: Combo with available sensors
        'ColorBasic: Combo with basic colors for the regular text font
        'ColorRGB: Combo with common RGB colors = 16bitinteger
        'ComboOnOff: Combo with options (Disabled=0, Enabled=1)
        'ComboYesNo: Combo with options (Yes=Yes, No=No)
        'TextSize: Combo with options (Extra Small=4, Very Small=5, Small=10, Normal=15, Big=20, Very Big=30, Extreme=40)
        'FontStyle2: Combo with options (Regular Font=0, Square Font=1, Numbers Font 1=2
        'Orientation: Combo with options (Horizontal=0, Vertical=1)
        'Here you can also load your custom comboboxes
        Return New Hashtable
    End Function

    Public Function LCDSys2_CreateOptions(sensorId As String, elementData As Hashtable) As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.LCDSys2_CreateOptions
        'Same options as lcd1
        Return CreateOptions(sensorId, elementData)
    End Function


    Function SensorHasCustomDraw(sensorId As String) As Boolean Implements GOverlayPlugin.Interfaces.IPlugin.SensorHasCustomDraw       
        Return False
    End Function

    Public Function PluginOptionsDefault() As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.PluginOptionsDefault
        'Set the default values you want to have on plugin, if the user doesnt change any option, he will have this settings
        Dim options As New Hashtable
        options("xmlfile") = ""
        Return options
    End Function
    Public Function PluginOptions(pluginCurrentOptions As Hashtable) As Hashtable Implements GOverlayPlugin.Interfaces.IPlugin.PluginOptions
        'Set the options the user will have when going to the plugins tab and clicking on your plugin
        'The availalbe option_type are teh same as CreateOptions function
        Dim options As New Hashtable
        'Option: option_index as integer, option_data as ArrayList
        'Option_Data: option_type as string, option_label as string, option_name as string (no spaces, no _)
        options.Add(0, New ArrayList({"Text", "XML file of Aquasuite sensors", "xmlfile"}))
        'options.Add(0, New ArrayList({"TextMulti", "Images Match finder", "reqimages"}))
        'options.Add(1, New ArrayList({"Button", "Upload Images", "reqimagesbutton"}))
        Return options
    End Function

    Public Function DisplayOnLCD(sensorId As String, elementData As Hashtable, pluginOptions As Hashtable, cacheRuns As Integer) As ArrayList Implements GOverlayPlugin.Interfaces.IPlugin.DisplayOnLCD
        Return New ArrayList()
    End Function

    Public Function LCDSys2_DisplayOnLCD(sensorId As String, elementData As Hashtable, pluginOptions As Hashtable, cacheRuns As Integer) As ArrayList Implements GOverlayPlugin.Interfaces.IPlugin.LCDSys2_DisplayOnLCD
        Return New ArrayList()
    End Function

    Public Function percToDeg(perc)
        Return perc * 360
    End Function

    Public Function percToRad(perc)
        Return degToRad(percToDeg(perc))
    End Function

    Public Function degToRad(deg)
        Return deg * Math.PI / 180
    End Function

    Public Function convertcolorto16bit(cr, cg, cb)

        Dim R As Double
        Dim G As Double
        Dim B As Double

        R = cr / 256 * 32
        G = cg / 256 * 64
        B = cb / 256 * 32

        R = Math.Floor(R)
        G = Math.Floor(G)
        B = Math.Floor(B)

        Dim final As Int32 = (CInt(R) << 11)
        final = final + Int(G << 5)
        final = final + Int(B)

        Return final

    End Function


    Private Function GrabData()
        Try
            Dim xmlfile As String = ""
            xmlfile = objHost.AccessHost("plugin_options", "AyteeDE.AquasuiteConnector", "xmlfile", False)

            Dim xmldoc As New XmlDataDocument()
            Dim xmlnode As XmlNodeList
            Dim i As Integer
            Dim str As String
            Dim fs As New FileStream(xmlfile, FileMode.Open, FileAccess.Read)
            xmldoc.Load(fs)
            fs.Close()
            xmlnode = xmldoc.GetElementsByTagName("LogDataSet")
            For i = 0 To xmlnode.Count - 1
                Dim sensorName As String = xmlnode(i).ChildNodes.Item(2).InnerText.Trim()
                Dim sensorType As String = xmlnode(i).ChildNodes.Item(4).InnerText.Trim()
                Dim sensorStringValue As String = xmlnode(i).ChildNodes.Item(1).InnerText.Trim().Replace(".", ",")
                Dim sensorDecimalValue As Decimal = Convert.ToDecimal(sensorStringValue)
                Dim sensorIntValue As Int32 = Convert.ToInt32(sensorDecimalValue)

                Dim sensorReturnValue = ""

                Select Case sensorType
                    Case "TEMPERATURE_C"
                        sensorReturnValue = sensorDecimalValue.ToString("0.0")
                    Case "WATT"
                        sensorReturnValue = sensorIntValue
                    Case "FREQ_MHZ"
                        sensorReturnValue = sensorIntValue
                    Case "DATA_SPEED_MB_S"
                        sensorReturnValue = sensorDecimalValue.ToString("0.00")
                    Case Else
                        sensorReturnValue = sensorIntValue
                End Select


                td("AyteeDE." & sensorType & "." & sensorName) = sensorReturnValue
            Next
        Catch ex As Exception
            objHost.DebugMessage("Error reading sensor values:" & ex.Message & ": " & ex.StackTrace)
        End Try

    End Function

#Region "Native API Signatures and Types"

    ''' <summary>
    ''' Access rights for file mapping objects
    ''' http://msdn.microsoft.com/en-us/library/aa366559.aspx
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum FileMapAccess
        FILE_MAP_COPY = 1
        FILE_MAP_WRITE = 2
        FILE_MAP_READ = 4
        FILE_MAP_ALL_ACCESS = &HF001F
    End Enum


    ''' <summary>
    ''' Represents a wrapper class for a file mapping handle. 
    ''' </summary>
    ''' <remarks></remarks>
    <SuppressUnmanagedCodeSecurity(), _
    HostProtection(SecurityAction.LinkDemand, MayLeakOnAbort:=True)> _
    Friend NotInheritable Class SafeFileMappingHandle
        Inherits SafeHandleZeroOrMinusOneIsInvalid

        <SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode:=True)> _
        Private Sub New()
            MyBase.New(True)
        End Sub

        <SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode:=True)> _
        Public Sub New(ByVal handle As IntPtr, ByVal ownsHandle As Boolean)
            MyBase.New(ownsHandle)
            MyBase.SetHandle(handle)
        End Sub

        <ReliabilityContract(Consistency.WillNotCorruptState, Cer.Success), _
        DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
        Private Shared Function CloseHandle(ByVal handle As IntPtr) _
        As <MarshalAs(UnmanagedType.Bool)> Boolean
        End Function

        Protected Overrides Function ReleaseHandle() As Boolean
            Return SafeFileMappingHandle.CloseHandle(MyBase.handle)
        End Function

    End Class


    Friend ReadOnly INVALID_HANDLE_VALUE As New IntPtr(-1)


    ''' <summary>
    ''' The class exposes Windows APIs used in this code sample.
    ''' </summary>
    ''' <remarks></remarks>
    <SuppressUnmanagedCodeSecurity()> _
    Friend Class NativeMethod

        ''' <summary>
        ''' Opens a named file mapping object.
        ''' </summary>
        ''' <param name="dwDesiredAccess">
        ''' The access to the file mapping object. This access is checked against 
        ''' any security descriptor on the target file mapping object.
        ''' </param>
        ''' <param name="bInheritHandle">
        ''' If this parameter is TRUE, a process created by the CreateProcess 
        ''' function can inherit the handle; otherwise, the handle cannot be 
        ''' inherited.
        ''' </param>
        ''' <param name="lpName">
        ''' The name of the file mapping object to be opened.
        ''' </param>
        ''' <returns>
        ''' If the function succeeds, the return value is an open handle to the 
        ''' specified file mapping object.
        ''' </returns>
        <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
        Public Shared Function OpenFileMapping( _
            ByVal dwDesiredAccess As FileMapAccess, _
            ByVal bInheritHandle As Boolean, _
            ByVal lpName As String) _
            As SafeFileMappingHandle
        End Function


        ''' <summary>
        ''' Maps a view of a file mapping into the address space of a calling 
        ''' process.
        ''' </summary>
        ''' <param name="hFileMappingObject">
        ''' A handle to a file mapping object. The CreateFileMapping and 
        ''' OpenFileMapping functions return this handle.
        ''' </param>
        ''' <param name="dwDesiredAccess">
        ''' The type of access to a file mapping object, which determines the 
        ''' protection of the pages.
        ''' </param>
        ''' <param name="dwFileOffsetHigh">
        ''' A high-order DWORD of the file offset where the view begins.
        ''' </param>
        ''' <param name="dwFileOffsetLow">
        ''' A low-order DWORD of the file offset where the view is to begin.
        ''' </param>
        ''' <param name="dwNumberOfBytesToMap">
        ''' The number of bytes of a file mapping to map to the view. All bytes 
        ''' must be within the maximum size specified by CreateFileMapping.
        ''' </param>
        ''' <returns>
        ''' If the function succeeds, the return value is the starting address of
        ''' the mapped view.
        ''' </returns>
        <DllImport("Kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
        Public Shared Function MapViewOfFile( _
            ByVal hFileMappingObject As SafeFileMappingHandle, _
            ByVal dwDesiredAccess As FileMapAccess, _
            ByVal dwFileOffsetHigh As UInt32, _
            ByVal dwFileOffsetLow As UInt32, _
            ByVal dwNumberOfBytesToMap As UInt32) _
            As IntPtr
        End Function


        ''' <summary>
        ''' Unmaps a mapped view of a file from the calling process's address 
        ''' space.
        ''' </summary>
        ''' <param name="lpBaseAddress">
        ''' A pointer to the base address of the mapped view of a file that is to 
        ''' be unmapped.
        ''' </param>
        ''' <returns></returns>
        <DllImport("Kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
        Public Shared Function UnmapViewOfFile( _
            ByVal lpBaseAddress As IntPtr) _
            As <MarshalAs(UnmanagedType.Bool)> Boolean
        End Function

    End Class

#End Region
End Class